-- The default rotations generator for ROGUES.
local druidRotationsGenerator = function ()
	local rotation = {
		["defaultRotation/druid/balance"] = {
			["ActionList"] = {
				["defaultRotation/druid/mark_of_the_wild"] = {
					["v_p_needbuff"] = "1126",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "1126",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "768",
					["v_actionicon"] = "1126",
				},
				["defaultRotation/druid/innervate"] = {
					["v_gcdspell"] = "765",
					["v_p_unitpowertype"] = "0",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "29166",
					["v_actionicon"] = "29166",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "<=75%",
					["b_p_unitpower"] = true,
				},
				["defaultRotation/druid/starfire_celestial_alignment"] = {
					["v_gcdspell"] = "768",
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "2912",
					["v_actionicon"] = "2912",
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_112071",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/moonfire_eclipse"] = {
					["v_p_needbuff"] = "_112071",
					["b_p_needbuff"] = true,
					["v_actionicon"] = "8921",
					["v_gcdspell"] = "768",
					["v_t_needsdebuff"] = "_8921^3",
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "8921",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_48518",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/sunfire_eclipse"] = {
					["v_p_needbuff"] = "_112071",
					["b_p_needbuff"] = true,
					["v_actionicon"] = "93402",
					["v_gcdspell"] = "768",
					["v_t_needsdebuff"] = "_93402^3",
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "93402",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_48517",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/wrath_solar_to_lunar"] = {
					["b_p_eclipse"] = true,
					["v_gcdspell"] = "768",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "5176",
					["v_p_eclipse"] = "moon",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "5176",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/faerie_fire"] = {
					["v_t_needsdebuff"] = "113746#3^5",
					["v_gcdspell"] = "768",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "770",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "770",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/force_of_nature"] = {
					["v_gcdspell"] = "0",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "106737",
					["v_spellname"] = "106737",
					["v_checkothercdvalue"] = "<2",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_checkothercdname"] = "106737",
				},
				["defaultRotation/druid/sunfire"] = {
					["v_t_needsdebuff"] = "_93402^3",
					["b_p_eclipse"] = true,
					["v_gcdspell"] = "768",
					["v_p_eclipse"] = "moon",
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "93402",
					["v_spellname"] = "93402",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/moonfire_astral_communion"] = {
					["v_t_needsdebuff"] = "_8921^3",
					["v_gcdspell"] = "768",
					["b_p_havebuff"] = true,
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "8921",
					["v_spellname"] = "8921",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_112071",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/celestial_alignment"] = {
					["v_gcdspell"] = "0",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "112071",
					["v_spellname"] = "112071",
					["v_checkothercdvalue"] = "<2",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_checkothercdname"] = "112071",
				},
				["defaultRotation/druid/starfall"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "48505",
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "768",
					["v_actionicon"] = "48505",
				},
				["defaultRotation/druid/wrath"] = {
					["b_p_eclipse"] = true,
					["v_gcdspell"] = "768",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "5176",
					["v_p_eclipse"] = "none",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "5176",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/moonkin_form"] = {
					["v_p_needbuff"] = "24858",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "24858",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "768",
					["v_actionicon"] = "24858",
				},
				["defaultRotation/druid/incarnation"] = {
					["v_durationstartedtime"] = 0,
					["v_gcdspell"] = "0",
					["v_keybind"] = "<keybind>",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "106731",
					["v_spellname"] = "106731",
					["b_p_havebuff"] = true,
					["v_checkothercdvalue"] = "<2",
					["v_p_havebuff"] = "48518|48517",
					["v_checkothercdname"] = "106731",
				},
				["defaultRotation/druid/astral_communion"] = {
					["v_p_eclipse"] = "none",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "127663",
					["b_p_eclipse"] = true,
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "768",
					["v_actionicon"] = "127663",
				},
				["defaultRotation/druid/starsurge"] = {
					["b_rangecheck"] = true,
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "78674",
					["v_spellname"] = "78674",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_checkothercdvalue"] = "<1",
					["v_checkothercdname"] = "78674",
				},
				["defaultRotation/druid/nature_s_vigil"] = {
					["v_gcdspell"] = "0",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "124974",
					["v_spellname"] = "124974",
					["v_checkothercdvalue"] = "<2",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_checkothercdname"] = "124974",
				},
				["defaultRotation/druid/starsurge_shooting_stars"] = {
					["v_durationstartedtime"] = 0,
					["v_gcdspell"] = "768",
					["v_checkothercdvalue"] = "<1",
					["b_rangecheck"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "78674",
					["v_spellname"] = "78674",
					["b_p_havebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "93400",
					["v_checkothercdname"] = "78674",
				},
				["defaultRotation/druid/starfire_lunar_to_solar"] = {
					["b_p_eclipse"] = true,
					["v_gcdspell"] = "768",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "2912",
					["v_p_eclipse"] = "sun",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "2912",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/moonfire"] = {
					["v_t_needsdebuff"] = "_8921^3",
					["b_p_eclipse"] = true,
					["v_gcdspell"] = "768",
					["v_p_eclipse"] = "sun",
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "8921",
					["v_spellname"] = "8921",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["b_rangecheck"] = true,
				},
			},
			["SortedActions"] = {
				"defaultRotation/druid/mark_of_the_wild", -- [1]
				"defaultRotation/druid/moonkin_form", -- [2]
				"defaultRotation/druid/astral_communion", -- [3]
				"defaultRotation/druid/celestial_alignment", -- [4]
				"defaultRotation/druid/force_of_nature", -- [5]
				"defaultRotation/druid/nature_s_vigil", -- [6]
				"defaultRotation/druid/starfall", -- [7]
				"defaultRotation/druid/starsurge_shooting_stars", -- [8]
				"defaultRotation/druid/incarnation", -- [9]
				"defaultRotation/druid/moonfire_astral_communion", -- [10]
				"defaultRotation/druid/moonfire_eclipse", -- [11]
				"defaultRotation/druid/sunfire_eclipse", -- [12]
				"defaultRotation/druid/moonfire", -- [13]
				"defaultRotation/druid/sunfire", -- [14]
				"defaultRotation/druid/faerie_fire", -- [15]
				"defaultRotation/druid/innervate", -- [16]
				"defaultRotation/druid/starsurge", -- [17]
				"defaultRotation/druid/starfire_celestial_alignment", -- [18]
				"defaultRotation/druid/wrath_solar_to_lunar", -- [19]
				"defaultRotation/druid/starfire_lunar_to_solar", -- [20]
				"defaultRotation/druid/wrath", -- [21]
			},
			["keybind"] = "<keybind>",
		},
		["defaultRotation/druid/feral"] = {
			["ActionList"] = {
				["defaultRotation/druid/mark_of_the_wild"] = {
					["v_p_needbuff"] = "1126",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "1126",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "768",
					["v_actionicon"] = "1126",
				},
				["defaultRotation/druid/shred"] = {
					["b_gcombopoints"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "5221",
					["v_actionicon"] = "5221",
					["v_keybind"] = "<keybind>",
					["v_gcombopoints"] = "1",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/renewal"] = {
					["v_p_hp"] = "<50%",
					["v_gcdspell"] = "0",
					["b_p_hp"] = true,
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "108238",
					["v_actionicon"] = "108238",
					["v_checkothercdvalue"] = "<2",
					["v_keybind"] = "<keybind>",
					["v_checkothercdname"] = "108238",
				},
				["defaultRotation/druid/cenarion_ward"] = {
					["v_gcdspell"] = "0",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "102351",
					["v_spellname"] = "102351",
					["v_checkothercdvalue"] = "<2",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_checkothercdname"] = "102351",
				},
				["defaultRotation/druid/cat_form"] = {
					["v_p_needbuff"] = "768",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "768",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "768",
					["v_actionicon"] = "768",
				},
				["defaultRotation/druid/nature_s_swiftness"] = {
					["v_p_needbuff"] = "132158",
					["b_p_needbuff"] = true,
					["v_gcdspell"] = "0",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "132158",
					["v_keybind"] = "<keybind>",
					["v_checkothercdvalue"] = "<2",
					["v_actionicon"] = "132158",
					["v_checkothercdname"] = "108238",
				},
				["defaultRotation/druid/healing_touch"] = {
					["v_gcdspell"] = "768",
					["v_durationstartedtime"] = 0,
					["v_p_hp"] = "<50%",
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "5185",
					["v_spellname"] = "5185",
					["b_p_havebuff"] = true,
					["b_p_hp"] = true,
					["v_p_havebuff"] = "132158",
					["v_keybind"] = "<keybind>",
				},
				["defaultRotation/druid/rip"] = {
					["v_t_needsdebuff"] = "_1079^5",
					["b_p_combopoints"] = true,
					["v_gcdspell"] = "768",
					["v_togglename"] = "Toggle 1",
					["v_p_combopoints"] = "=5",
					["v_actionicon"] = "1079",
					["v_spellname"] = "1079",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/tiger_s_fury"] = {
					["v_gcdspell"] = "0",
					["v_p_unitpowertype"] = "3",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "5217",
					["v_actionicon"] = "5217",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "<30",
					["b_p_unitpower"] = true,
				},
				["defaultRotation/druid/faerie_fire"] = {
					["v_t_needsdebuff"] = "113746#3^5",
					["v_gcdspell"] = "768",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "770",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "770",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/incarnation"] = {
					["v_p_needbuff"] = "50334",
					["b_p_needbuff"] = true,
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "106731",
					["v_keybind"] = "<keybind>",
					["v_checkothercdvalue"] = "<2",
					["v_actionicon"] = "106731",
					["v_checkothercdname"] = "106731",
				},
				["defaultRotation/druid/berserk"] = {
					["v_gcdspell"] = "0",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "106951",
					["v_spellname"] = "106951",
					["v_checkothercdvalue"] = "<2",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_checkothercdname"] = "106951",
				},
				["defaultRotation/druid/mangle"] = {
					["v_gcdspell"] = "768",
					["b_gcombopoints"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "33917",
					["v_spellname"] = "33917",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_gcombopoints"] = "1",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/ferocious_bite_rip"] = {
					["b_t_hasdebuff"] = true,
					["v_t_hp"] = "<=25%",
					["b_p_combopoints"] = true,
					["v_gcdspell"] = "768",
					["v_togglename"] = "Toggle 1",
					["b_rangecheck"] = true,
					["v_p_combopoints"] = "=5",
					["v_durationstartedtime"] = 0,
					["b_t_hp"] = true,
					["v_spellname"] = "22568",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "22568",
					["v_t_hasdebuff"] = "_1079",
				},
				["defaultRotation/druid/rake"] = {
					["v_t_needsdebuff"] = "_1822^3",
					["v_gcdspell"] = "768",
					["v_actionicon"] = "1822",
					["b_gcombopoints"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "1822",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_gcombopoints"] = "1",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/nature_s_vigil"] = {
					["v_gcdspell"] = "0",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "124974",
					["v_spellname"] = "124974",
					["v_checkothercdvalue"] = "<2",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_checkothercdname"] = "124974",
				},
				["defaultRotation/druid/ferocious_bite"] = {
					["b_p_combopoints"] = true,
					["v_gcdspell"] = "768",
					["v_p_combopoints"] = "=5",
					["v_actionicon"] = "22568",
					["v_spellname"] = "22568",
					["v_togglename"] = "Toggle 1",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/force_of_nature"] = {
					["v_gcdspell"] = "0",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "102706",
					["v_spellname"] = "102706",
					["v_checkothercdvalue"] = "<2",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_checkothercdname"] = "102706",
				},
				["defaultRotation/druid/savage_roar"] = {
					["v_p_needbuff"] = "52610^5",
					["b_p_needbuff"] = true,
					["b_p_combopoints"] = true,
					["v_gcdspell"] = "768",
					["v_p_combopoints"] = ">=1",
					["v_actionicon"] = "52610",
					["v_spellname"] = "52610",
					["v_keybind"] = "<keybind>",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
				},
			},
			["SortedActions"] = {
				"defaultRotation/druid/mark_of_the_wild", -- [1]
				"defaultRotation/druid/cat_form", -- [2]
				"defaultRotation/druid/cenarion_ward", -- [3]
				"defaultRotation/druid/renewal", -- [4]
				"defaultRotation/druid/healing_touch", -- [5]
				"defaultRotation/druid/nature_s_swiftness", -- [6]
				"defaultRotation/druid/nature_s_vigil", -- [7]
				"defaultRotation/druid/force_of_nature", -- [8]
				"defaultRotation/druid/incarnation", -- [9]
				"defaultRotation/druid/berserk", -- [10]
				"defaultRotation/druid/tiger_s_fury", -- [11]
				"defaultRotation/druid/savage_roar", -- [12]
				"defaultRotation/druid/ferocious_bite_rip", -- [13]
				"defaultRotation/druid/rip", -- [14]
				"defaultRotation/druid/ferocious_bite", -- [15]
				"defaultRotation/druid/faerie_fire", -- [16]
				"defaultRotation/druid/rake", -- [17]
				"defaultRotation/druid/shred", -- [18]
				"defaultRotation/druid/mangle", -- [19]
			},
			["keybind"] = "<keybind>",
		},
		["defaultRotation/druid/guardian"] = {
			["ActionList"] = {
				["defaultRotation/druid/mark_of_the_wild"] = {
					["v_p_needbuff"] = "1126",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "1126",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "768",
					["v_actionicon"] = "1126",
				},
				["defaultRotation/druid/nature_s_vigil"] = {
					["v_gcdspell"] = "0",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "124974",
					["v_spellname"] = "124974",
					["v_checkothercdvalue"] = "<2",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_checkothercdname"] = "124974",
				},
				["defaultRotation/druid/cenarion_ward"] = {
					["v_gcdspell"] = "0",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "102351",
					["v_spellname"] = "102351",
					["v_checkothercdvalue"] = "<2",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_checkothercdname"] = "102351",
				},
				["defaultRotation/druid/bear_form"] = {
					["v_p_needbuff"] = "5487",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "5487",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "768",
					["v_actionicon"] = "5487",
				},
				["defaultRotation/druid/bear_hug"] = {
					["v_gcdspell"] = "0",
					["v_checkothercdvalue"] = "<2",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "102795",
					["v_spellname"] = "102795",
					["b_rangecheck"] = true,
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_checkothercdname"] = "102795",
				},
				["defaultRotation/druid/nature_s_swiftness"] = {
					["v_p_needbuff"] = "132158",
					["b_p_needbuff"] = true,
					["v_gcdspell"] = "0",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "132158",
					["v_checkothercdvalue"] = "<2",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "132158",
					["v_checkothercdname"] = "108238",
				},
				["defaultRotation/druid/maul"] = {
					["v_gcdspell"] = "768",
					["b_p_unitpower"] = true,
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "1",
					["v_spellname"] = "6807",
					["v_actionicon"] = "6807",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=90%",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/faerie_fire"] = {
					["v_t_needsdebuff"] = "113746#3^5",
					["v_gcdspell"] = "768",
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "770",
					["v_spellname"] = "770",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/incarnation"] = {
					["v_p_needbuff"] = "50334",
					["b_p_needbuff"] = true,
					["v_checkothercdvalue"] = "<2",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "106731",
					["v_spellname"] = "106731",
					["b_rangecheck"] = true,
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_checkothercdname"] = "106731",
				},
				["defaultRotation/druid/enrage"] = {
					["b_gunitpower"] = true,
					["v_gunitpowertype"] = "1",
					["v_toggleicon"] = "5229",
					["v_gcdspell"] = "768",
					["v_p_unitpower"] = "<=20%",
					["v_actionicon"] = "5229",
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "1",
					["v_spellname"] = "5229",
					["b_p_unitpower"] = true,
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "20",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/druid/berserk"] = {
					["v_p_needbuff"] = "106731",
					["b_p_needbuff"] = true,
					["v_gcdspell"] = "0",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "50334",
					["v_checkothercdvalue"] = "<2",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "50334",
					["v_checkothercdname"] = "50334",
				},
				["defaultRotation/druid/mangle"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "33878",
					["v_actionicon"] = "33878",
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "768",
					["b_rangecheck"] = true,
				},
				["defaultRotation/druid/frenzied_regeneration"] = {
					["v_togglename"] = "Toggle 1",
					["v_gcdspell"] = "768",
					["v_durationstartedtime"] = 0,
					["b_p_unitpower"] = true,
					["v_p_hp"] = "<60%",
					["v_p_unitpowertype"] = "1",
					["v_spellname"] = "22842",
					["v_actionicon"] = "22842",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">60%",
					["b_p_hp"] = true,
				},
				["defaultRotation/druid/healing_touch"] = {
					["v_gcdspell"] = "768",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_p_hp"] = "<50%",
					["b_p_havebuff"] = true,
					["v_spellname"] = "5185",
					["v_actionicon"] = "5185",
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "132158",
					["b_p_hp"] = true,
				},
				["defaultRotation/druid/savage_defense"] = {
					["v_checkothercdvalue"] = "<3",
					["b_p_unitpower"] = true,
					["v_gcdspell"] = "768",
					["v_durationstartedtime"] = 0,
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "1",
					["v_spellname"] = "62606",
					["v_actionicon"] = "62606",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=60%",
					["v_checkothercdname"] = "62606",
				},
				["defaultRotation/druid/renewal"] = {
					["v_checkothercdvalue"] = "<2",
					["v_gcdspell"] = "0",
					["v_togglename"] = "Toggle 1",
					["b_checkothercd"] = true,
					["v_p_hp"] = "<50%",
					["v_actionicon"] = "108238",
					["v_spellname"] = "108238",
					["v_keybind"] = "<keybind>",
					["b_p_hp"] = true,
					["v_durationstartedtime"] = 0,
					["v_checkothercdname"] = "108238",
				},
				["defaultRotation/druid/force_of_nature"] = {
					["v_gcdspell"] = "0",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "102706",
					["v_spellname"] = "102706",
					["v_checkothercdvalue"] = "<2",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_checkothercdname"] = "102706",
				},
				["defaultRotation/druid/thrash"] = {
					["v_t_needsdebuff"] = "115798^5",
					["v_gcdspell"] = "768",
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "77758",
					["v_spellname"] = "77758",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["b_t_dr"] = true,
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/druid/lacerate"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "33745",
					["v_actionicon"] = "33745",
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "768",
					["b_rangecheck"] = true,
				},
			},
			["SortedActions"] = {
				"defaultRotation/druid/mark_of_the_wild", -- [1]
				"defaultRotation/druid/bear_form", -- [2]
				"defaultRotation/druid/cenarion_ward", -- [3]
				"defaultRotation/druid/renewal", -- [4]
				"defaultRotation/druid/healing_touch", -- [5]
				"defaultRotation/druid/nature_s_swiftness", -- [6]
				"defaultRotation/druid/nature_s_vigil", -- [7]
				"defaultRotation/druid/frenzied_regeneration", -- [8]
				"defaultRotation/druid/savage_defense", -- [9]
				"defaultRotation/druid/thrash", -- [10]
				"defaultRotation/druid/mangle", -- [11]
				"defaultRotation/druid/force_of_nature", -- [12]
				"defaultRotation/druid/faerie_fire", -- [13]
				"defaultRotation/druid/incarnation", -- [14]
				"defaultRotation/druid/berserk", -- [15]
				"defaultRotation/druid/bear_hug", -- [16]
				"defaultRotation/druid/enrage", -- [17]
				"defaultRotation/druid/lacerate", -- [18]
				"defaultRotation/druid/maul", -- [19]
			},
			["keybind"] = "<keybind>",
		},
	}

	-- Restore the true state of the saved data.
	--	return RotationBuilder:restoreTable({}, rotation);
	return rotation;
end

local druidRotationsGeneratorData = {
	["version"] = 1, 
	["generator"] = druidRotationsGenerator
};

RotationBuilder:addDefaultRotationsGenerator("DRUID", druidRotationsGeneratorData);