-- The default rotations generator for SHAMANS.
local shamanRotationsGenerator = function ()
	local rotation = {
		["defaultRotation/shaman/elemental"] = {
			["ActionList"] = {
				["defaultRotation/shaman/ancestral_swiftness"] = {
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "16188",
					["v_spellname"] = "16188",
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "0",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/shaman/lightning_bolt"] = {
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "403",
					["v_spellname"] = "403",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "324",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/ascendance"] = {
					["v_p_needbuff"] = "114050",
					["b_p_needbuff"] = true,
					["v_gcdspell"] = "0",
					["v_actionicon"] = "114049",
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "114049",
					["b_t_boss"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "16166",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/shaman/unleash_elements_unleashed_fury"] = {
					["v_p_knowspell"] = "117012",
					["v_gcdspell"] = "324",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "73680",
					["v_spellname"] = "73680",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/searing_totem_refresh"] = {
					["v_keybind"] = "<keybind>",
					["v_rangespell"] = "403",
					["b_p_firetotemactive"] = true,
					["v_p_firetotemactive"] = "3599",
					["v_actionicon"] = "3599",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "3599",
					["b_p_firetotemtimeleft"] = true,
					["v_p_firetotemtimeleft"] = "<=3",
					["v_gcdspell"] = "3599",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/searing_totem"] = {
					["b_p_firetoteminactive"] = true,
					["v_gcdspell"] = "3599",
					["v_rangespell"] = "403",
					["b_p_firetotemtimeleft"] = true,
					["v_keybind"] = "<keybind>",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "3599",
					["v_actionicon"] = "3599",
					["v_p_firetotemtimeleft"] = "=0",
					["v_p_firetoteminactive"] = "3599",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/earth_shock"] = {
					["v_gcdspell"] = "324",
					["b_p_havebuff"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "8042",
					["v_spellname"] = "8042",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "324#17",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/lava_burst_flame_shock"] = {
					["b_t_hasdebuff"] = true,
					["v_gcdspell"] = "324",
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "51505",
					["v_spellname"] = "51505",
					["b_rangecheck"] = true,
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_t_hasdebuff"] = "_8050^3",
				},
				["defaultRotation/shaman/lava_burst"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "51505",
					["v_actionicon"] = "51505",
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "324",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/elemental_mastery"] = {
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "16166",
					["v_spellname"] = "16166",
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "0",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/shaman/elemental_blast"] = {
					["v_p_knowspell"] = "117014",
					["v_gcdspell"] = "324",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "117014",
					["v_spellname"] = "117014",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/liquid_magma"] = {
					["v_togglename"] = "Toggle 1",
					["v_gcdspell"] = "324",
					["b_p_firetotemactive"] = true,
					["v_p_firetotemactive"] = "3599",
					["b_p_firetotemtimeleft"] = true,
					["v_actionicon"] = "152255",
					["v_spellname"] = "152255",
					["v_keybind"] = "<keybind>",
					["v_p_firetotemtimeleft"] = ">=13",
					["v_durationstartedtime"] = 0,
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/flame_shock"] = {
					["v_t_needsdebuff"] = "_8050^9",
					["v_gcdspell"] = "324",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "8050",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "8050",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/lightning_shield"] = {
					["v_p_needbuff"] = "324",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "324",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "324",
					["v_actionicon"] = "324",
				},
			},
			["SortedActions"] = {
				"defaultRotation/shaman/lightning_shield", -- [1]
				"defaultRotation/shaman/elemental_mastery", -- [2]
				"defaultRotation/shaman/ascendance", -- [3]
				"defaultRotation/shaman/ancestral_swiftness", -- [4]
				"defaultRotation/shaman/liquid_magma", -- [5]
				"defaultRotation/shaman/lava_burst_flame_shock", -- [6]
				"defaultRotation/shaman/flame_shock", -- [7]
				"defaultRotation/shaman/earth_shock", -- [8]
				"defaultRotation/shaman/elemental_blast", -- [9]
				"defaultRotation/shaman/lava_burst", -- [10]
				"defaultRotation/shaman/searing_totem", -- [11]
				"defaultRotation/shaman/searing_totem_refresh", -- [12]
				"defaultRotation/shaman/unleash_elements_unleashed_fury", -- [13]
				"defaultRotation/shaman/lightning_bolt", -- [14]
			},
			["keybind"] = "<keybind>",
		},
		["defaultRotation/shaman/enhancement"] = {
			["ActionList"] = {
				["defaultRotation/shaman/searing_totem_refresh"] = {
					["v_p_firetotemactive"] = "3599",
					["b_p_firetotemactive"] = true,
					["v_rangespell"] = "8050",
					["v_p_firetotemtimeleft"] = "<20",
					["v_togglename"] = "Toggle 1",
					["b_p_firetotemtimeleft"] = true,
					["v_actionicon"] = "3599",
					["v_spellname"] = "3599",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "3599",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/stormstrike_execute"] = {
					["v_p_needbuff"] = "114051",
					["b_rangecheck"] = true,
					["b_p_needbuff"] = true,
					["v_spellname"] = "17364",
					["v_rangespell"] = "60103",
					["v_p_knowspell"] = "108283",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "17364",
					["b_t_hp"] = true,
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "324",
					["v_t_hp"] = "<5%",
				},
				["defaultRotation/shaman/stormstrike"] = {
					["v_p_needbuff"] = "114051",
					["b_p_needbuff"] = true,
					["v_gcdspell"] = "324",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "17364",
					["v_actionicon"] = "17364",
					["v_keybind"] = "<keybind>",
					["v_rangespell"] = "60103",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/frost_shock"] = {
					["v_gcdspell"] = "324",
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "8056",
					["v_spellname"] = "8056",
					["v_p_knownotspell"] = "152257",
					["b_p_knownotspell"] = true,
					["v_keybind"] = "<keybind>",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/frost_shock_elemental_fusion"] = {
					["b_t_hasdebuff"] = true,
					["v_p_knowspell"] = "152257",
					["v_gcdspell"] = "324",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "8056",
					["v_t_hasdebuff"] = "_8050^15",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "8056",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/lava_lash"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "60103",
					["v_actionicon"] = "60103",
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "324",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/windstrike_execute"] = {
					["b_rangecheck"] = true,
					["v_gcdspell"] = "324",
					["v_p_knowspell"] = "108283",
					["v_durationstartedtime"] = 0,
					["v_rangespell"] = "403",
					["v_actionicon"] = "115356",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["b_t_hp"] = true,
					["v_spellname"] = "17364",
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "114051",
					["v_t_hp"] = "<5%",
				},
				["defaultRotation/shaman/elemental_blast"] = {
					["v_p_knowspell"] = "117014",
					["v_gcdspell"] = "324",
					["v_durationstartedtime"] = 0,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "117014",
					["v_actionicon"] = "117014",
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "53817#1",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/feral_spirit"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "51533",
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "324",
					["v_actionicon"] = "51533",
				},
				["defaultRotation/shaman/ascendance"] = {
					["v_p_needbuff"] = "114051",
					["b_p_needbuff"] = true,
					["v_gcdspell"] = "0",
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "114049",
					["v_spellname"] = "114049",
					["b_t_boss"] = true,
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/shaman/stormstrike_2_charges"] = {
					["v_p_needbuff"] = "114051",
					["v_p_knowspell"] = "108283",
					["v_gcdspell"] = "324",
					["v_rangespell"] = "60103",
					["b_charges"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_charges"] = "2",
					["v_actionicon"] = "17364",
					["v_keybind"] = "<keybind>",
					["v_spellname"] = "17364",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/searing_totem"] = {
					["b_p_firetoteminactive"] = true,
					["v_togglename"] = "Toggle 1",
					["v_rangespell"] = "8050",
					["v_durationstartedtime"] = 0,
					["v_p_firetotemtimeleft"] = "<=3",
					["b_p_firetotemtimeleft"] = true,
					["v_actionicon"] = "3599",
					["v_spellname"] = "3599",
					["v_gcdspell"] = "3599",
					["v_keybind"] = "<keybind>",
					["v_p_firetoteminactive"] = "3599",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/elemental_mastery"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "16166",
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "0",
					["v_actionicon"] = "16166",
				},
				["defaultRotation/shaman/ancestral_swiftness"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "16188",
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "0",
					["v_actionicon"] = "16188",
				},
				["defaultRotation/shaman/lava_lash_execute"] = {
					["v_p_knowspell"] = "108283",
					["v_gcdspell"] = "324",
					["b_rangecheck"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["b_t_hp"] = true,
					["v_spellname"] = "60103",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "60103",
					["v_t_hp"] = "<5%",
				},
				["defaultRotation/shaman/lava_lash_2_charges"] = {
					["v_p_knowspell"] = "108283",
					["v_gcdspell"] = "324",
					["b_charges"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "60103",
					["v_actionicon"] = "60103",
					["v_keybind"] = "<keybind>",
					["v_charges"] = "2",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/lava_lash_echo"] = {
					["v_p_knowspell"] = "108283",
					["v_gcdspell"] = "324",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "60103",
					["v_spellname"] = "60103",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/flame_shock_elemental_fusion"] = {
					["v_t_needsdebuff"] = "_8050^9",
					["v_durationstartedtime"] = 0,
					["v_p_knownotspell"] = "152257",
					["v_gcdspell"] = "324",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "8050",
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "8050",
					["b_t_needsdebuff"] = true,
					["b_p_knownotspell"] = true,
					["v_p_havebuff"] = "73683^3&152257#2",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/unleash_elements"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "73680",
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "324",
					["v_actionicon"] = "73680",
				},
				["defaultRotation/shaman/lightning_shield"] = {
					["v_p_needbuff"] = "324",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "324",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "324",
					["v_actionicon"] = "324",
				},
				["defaultRotation/shaman/windstrike_ascendance"] = {
					["v_p_knowspell"] = "108283",
					["v_rangespell"] = "403",
					["v_gcdspell"] = "324",
					["v_actionicon"] = "115356",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "17364",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "114051^3",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/unleash_elements_unleashed_fury"] = {
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "73680",
					["v_p_knowspell"] = "117012",
					["v_keybind"] = "<keybind>",
					["v_gcdspell"] = "324",
					["v_actionicon"] = "73680",
				},
				["defaultRotation/shaman/lightning_bolt"] = {
					["v_gcdspell"] = "324",
					["v_actionicon"] = "403",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "403",
					["b_p_havebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "53817#1",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/windstrike"] = {
					["v_rangespell"] = "403",
					["b_p_havebuff"] = true,
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "115356",
					["v_spellname"] = "17364",
					["v_gcdspell"] = "324",
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "114051",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/liquid_magma"] = {
					["b_p_firetotemactive"] = true,
					["v_gcdspell"] = "324",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "152255",
					["v_togglename"] = "Toggle 1",
					["v_p_firetotemactive"] = "3599",
					["v_spellname"] = "152255",
					["v_durationstartedtime"] = 0,
					["v_p_firetotemtimeleft"] = ">=13",
					["b_p_firetotemtimeleft"] = true,
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/lightning_bolt_maelstrom_5"] = {
					["v_gcdspell"] = "324",
					["v_actionicon"] = "403",
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "403",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "53817#5",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/elemental_blast_maelstrom_4+"] = {
					["v_p_knowspell"] = "117014",
					["v_gcdspell"] = "324",
					["v_actionicon"] = "117014",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "117014",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "53817#4",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/flame_shock"] = {
					["v_t_needsdebuff"] = "_8050^9",
					["v_actionicon"] = "8050",
					["v_p_knownotspell"] = "152257",
					["v_gcdspell"] = "324",
					["b_p_knownotspell"] = true,
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "8050",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "73683^3",
					["b_rangecheck"] = true,
				},
				["defaultRotation/shaman/windstrike_2_charges"] = {
					["v_gcdspell"] = "324",
					["v_actionicon"] = "115356",
					["v_p_knowspell"] = "108283",
					["v_charges"] = "2",
					["v_rangespell"] = "403",
					["b_charges"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "17364",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "114051",
					["b_rangecheck"] = true,
				},
			},
			["SortedActions"] = {
				"defaultRotation/shaman/lightning_shield", -- [1]
				"defaultRotation/shaman/elemental_mastery", -- [2]
				"defaultRotation/shaman/ascendance", -- [3]
				"defaultRotation/shaman/ancestral_swiftness", -- [4]
				"defaultRotation/shaman/feral_spirit", -- [5]
				"defaultRotation/shaman/liquid_magma", -- [6]
				"defaultRotation/shaman/searing_totem", -- [7]
				"defaultRotation/shaman/elemental_blast_maelstrom_4+", -- [8]
				"defaultRotation/shaman/unleash_elements_unleashed_fury", -- [9]
				"defaultRotation/shaman/windstrike_2_charges", -- [10]
				"defaultRotation/shaman/stormstrike_2_charges", -- [11]
				"defaultRotation/shaman/windstrike_ascendance", -- [12]
				"defaultRotation/shaman/windstrike_execute", -- [13]
				"defaultRotation/shaman/stormstrike_execute", -- [14]
				"defaultRotation/shaman/lava_lash_2_charges", -- [15]
				"defaultRotation/shaman/lava_lash_execute", -- [16]
				"defaultRotation/shaman/lightning_bolt_maelstrom_5", -- [17]
				"defaultRotation/shaman/windstrike", -- [18]
				"defaultRotation/shaman/lava_lash_echo", -- [19]
				"defaultRotation/shaman/stormstrike", -- [20]
				"defaultRotation/shaman/lava_lash", -- [21]
				"defaultRotation/shaman/unleash_elements", -- [22]
				"defaultRotation/shaman/flame_shock_elemental_fusion", -- [23]
				"defaultRotation/shaman/flame_shock", -- [24]
				"defaultRotation/shaman/elemental_blast", -- [25]
				"defaultRotation/shaman/frost_shock_elemental_fusion", -- [26]
				"defaultRotation/shaman/frost_shock", -- [27]
				"defaultRotation/shaman/lightning_bolt", -- [28]
				"defaultRotation/shaman/searing_totem_refresh", -- [29]
			},
			["keybind"] = "<keybind>",
		},
	}

	-- Restore the true state of the saved data.
	--	return RotationBuilder:restoreTable({}, rotation);
	return rotation;
end

local shamanRotationsGeneratorData = {
	["version"] = 1, 
	["generator"] = shamanRotationsGenerator
};

RotationBuilder:addDefaultRotationsGenerator("SHAMAN", shamanRotationsGeneratorData);